using LinearAlgebra:
    Symmetric,
    Hermitian,
    UpperTriangular,
    UnitUpperTriangular,
    LowerTriangular,
    UnitLowerTriangular,
    UpperHessenberg,
    Tridiagonal,
    SymTridiagonal,
    Bidiagonal,
    Diagonal,
    UniformScaling

## Types for which a `generate` method is implemented. For parametric
## types, the parameters are arbitrary.
types_with_generate = [Bool,
                       UInt8, UInt16, UInt32, UInt64, UInt128,
                       Int128, Int16, Int32, Int64, Int8,
                       Float16, Float32, Float64,
                       Complex{Float64},
                       String, Char,
                       Vector{Float64}, Matrix{Int}, Array{Float32, 3},
                       BitVector, BitMatrix, BitArray{5},
                       SquareMatrix{Float64},
                       Symmetric{Float64, SquareMatrix{Float64}},
                       Hermitian{Float64, SquareMatrix{Float64}},
                       UpperTriangular{Float64},
                       UpperTriangular{Float64, SquareMatrix{Float64}},
                       UnitUpperTriangular{Float64},
                       UnitUpperTriangular{Float64, SquareMatrix{Float64}},
                       LowerTriangular{Float64},
                       LowerTriangular{Float64, SquareMatrix{Float64}},
                       UnitLowerTriangular{Float64},
                       UnitLowerTriangular{Float64, SquareMatrix{Float64}},
                       UpperHessenberg{Float64},
                       UpperHessenberg{Float64, Matrix{Float64}},
                       Tridiagonal{Float64},
                       Tridiagonal{Float64, Vector{Float64}},
                       SymTridiagonal{Float64},
                       SymTridiagonal{Float64, Vector{Float64}},
                       Bidiagonal{Float64},
                       Bidiagonal{Float64, Vector{Float64}},
                       Diagonal{Float64},
                       Diagonal{Float64, Vector{Float64}},
                       UniformScaling{Float64},
                       Union{Complex{Float64}, String, Char,
                             Vector{Float64}, Matrix{Int},
                             Array{Float32, 3}, BitVector, BitMatrix,
                             BitArray{5}, SquareMatrix{Float64},
                             Symmetric{Float64, SquareMatrix{Float64}}},
                       UnitRange{Float64},
                       StepRange{Int, Int}]
